unit FBaseEntidad;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls;

type
  TFormBaseEntidad = class(TForm)
    imgForm: TImage;
    btnOcultar: TButton;
    btnIncrustar: TButton;
    lblHora: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnOcultarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnIncrustarClick(Sender: TObject);
  private
    FDockOnMain: TNotifyEvent;
  public
    // Permite realizar el dock desde el formulario principal
    property DockOnMain:TNotifyEvent read FDockOnMain write FDockOnMain;
  end;

implementation

{$R *.dfm}

uses
  uUtils,
  Vcl.Imaging.pngimage;


procedure TFormBaseEntidad.btnOcultarClick(Sender: TObject);
begin
  Hide;
end;

procedure TFormBaseEntidad.btnIncrustarClick(Sender: TObject);
begin
  if Assigned(FDockOnMain) then
    FDockOnMain(Self);
end;

procedure TFormBaseEntidad.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TFormBaseEntidad.FormShow(Sender: TObject);
begin
  if Assigned(imgForm.Picture.Graphic) then
    try
      LoadPNGAsIcon(imgForm, Self.Icon);
    except
      // por ahora no quiero errores...
    end;

  lblHora.Caption := Format('Formulario creado a las [%s]', [FormatDateTime('dd/mm/yyyy hh:nn:ss', now)]);
end;

end.
