unit FMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Menus, Vcl.FormTabsBar, Vcl.ExtCtrls,
  Vcl.StdCtrls, Vcl.Samples.Spin, Vcl.AppEvnts;

type
  TFormMain = class(TForm)
    MainMenu1: TMainMenu;
    clientes1: TMenuItem;
    Clientes2: TMenuItem;
    Proveedores3: TMenuItem;
    Artculos1: TMenuItem;
    Archivo1: TMenuItem;
    Importar1: TMenuItem;
    N6Exportar1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    FormTabsBar1: TFormTabsBar;
    pnlDock: TPanel;
    pnlOpciones: TPanel;
    Label1: TLabel;
    lblFormsCreados: TLabel;
    chkIncrustar: TCheckBox;
    ApplicationEvents1: TApplicationEvents;
    CheckBox8: TCheckBox;
    pnlCompOpciones: TPanel;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    Label2: TLabel;
    edtMaxWidth: TSpinEdit;
    Label3: TLabel;
    edtMinWidth: TSpinEdit;
    chkStyle: TCheckBox;
    procedure N2Click(Sender: TObject);
    procedure Clientes2Click(Sender: TObject);
    procedure Proveedores3Click(Sender: TObject);
    procedure Artculos1Click(Sender: TObject);
    procedure FormTabsBar1AcceptForm(AForm: TForm; var AAccept: Boolean);
    procedure edtMaxWidthChange(Sender: TObject);
    procedure edtMinWidthChange(Sender: TObject);
    procedure FormTabsBar1Click(Sender: TObject);
    procedure ActualizarOpciones(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
    procedure chkStyleClick(Sender: TObject);
  private
    // Crear y abrir un formulario de una clase derivada de TBaseEntidad
    procedure OpenForm(aFormClass:TFormClass);
    // Numero de forms creados derivados de la clase TBaseEntidad
    procedure UpdateCreatedForms;
    // Permite dockar un formulari en el Main
    procedure DockOnMain(Sender:TObject);
  public

  end;

var
  FormMain: TFormMain;

implementation

{$R *.dfm}

uses
  Vcl.Themes, Vcl.Styles,
  FBaseentidad,
  FClientes, FProveedores, FArticulos;

procedure TFormMain.Artculos1Click(Sender: TObject);
begin
  OpenForm(TFormArticulos);
end;

procedure TFormMain.ActualizarOpciones;
begin
  FormTabsBar1.TabOptions.Draggable := CheckBox1.Checked;
  FormTabsBar1.TabOptions.MarkInvisibleForm := CheckBox2.Checked;
  FormTabsBar1.TabOptions.ShowCloseButton := CheckBox3.Checked;
  FormTabsBar1.TabOptions.ShowFormIcon := CheckBox4.Checked;
  FormTabsBar1.TabOptions.ShowFormSystemMenu := CheckBox5.Checked;
  FormTabsBar1.TabOptions.ShowHintForTruncatedCaption := CheckBox6.Checked;
  FormTabsBar1.ShowTabsMenuButton := CheckBox7.Checked;
end;

procedure TFormMain.CheckBox8Click(Sender: TObject);
begin
  if TCheckBox(Sender).Checked then
    VisualManager := FormTabsBar1
  else
    VisualManager := nil;
  pnlCompOpciones.Visible := TCheckBox(Sender).Checked;
end;

procedure TFormMain.chkStyleClick(Sender: TObject);
begin
  if (chkStyle.Checked) then
    TStyleManager.TrySetStyle('Amethyst Kamri')
  else
    TStyleManager.TrySetStyle('Windows')

end;

procedure TFormMain.Clientes2Click(Sender: TObject);
begin
  OpenForm(TFormClientes);
end;

procedure TFormMain.Proveedores3Click(Sender: TObject);
begin
  OpenForm(TFormProveedores);
end;

procedure TFormMain.DockOnMain(Sender: TObject);
begin
  TForm(Sender).Dock(pnlDock, pnlDock.ClientRect);
end;

procedure TFormMain.edtMaxWidthChange(Sender: TObject);
begin
  FormTabsBar1.TabMaxWidth := TSpinEdit(sender).Value;
end;

procedure TFormMain.edtMinWidthChange(Sender: TObject);
begin
  FormTabsBar1.TabMinWidth := TSpinEdit(sender).Value;
end;

procedure TFormMain.FormTabsBar1AcceptForm(AForm: TForm; var AAccept: Boolean);
begin
  AAccept := True;
  if chkIncrustar.Checked then
    AForm.Dock(pnlDock, pnlDock.ClientRect);
end;

procedure TFormMain.FormTabsBar1Click(Sender: TObject);
begin
  // actualixar los forms creados
  UpdateCreatedForms;
end;

procedure TFormMain.N2Click(Sender: TObject);
begin
  Close;
end;

procedure TFormMain.OpenForm(aFormClass: TFormClass);
begin
  var f:TForm := aFormClass.Create(Application);
  TFormBaseEntidad(f).DockOnMain := DockOnMain;
  // aadirla al FormTabsBar
  if Assigned(VisualManager) then
    VisualManager.AddForm(f);
  f.Show;

  // actualixar los forms creados
  UpdateCreatedForms;
end;

procedure TFormMain.UpdateCreatedForms;
var
  countF:integer;
begin
  countF := 0;
  // Nos interesa saber los que derivan slo, de la clase TFormBaseEntidad
  for var i := 0 to (Screen.FormCount - 1) do
    if (Screen.Forms[i] is TFormBaseEntidad) then
      Inc(countF);
  lblFormsCreados.Caption := Format('[%d] formularios creados',[countF]);
end;

end.
